// Generated by CoffeeScript 1.9.1
(function() {
  var DefaultShaper, Script, unicode;

  Script = require('../../layout/Script');

  unicode = require('unicode-properties');

  DefaultShaper = (function() {
    function DefaultShaper() {}

    DefaultShaper.getGlobalFeatures = function(script, isVertical) {
      var features;
      if (isVertical == null) {
        isVertical = false;
      }
      features = ['ccmp', 'locl', 'rlig', 'mark', 'mkmk'];
      switch (Script.direction(script)) {
        case 'ltr':
          features.push('ltra', 'ltrm');
          break;
        case 'rtl':
          features.push('rtla', 'rtlm');
      }
      if (isVertical) {
        features.push('vert');
      } else {
        features.push('calt', 'clig', 'liga', 'rclt', 'curs', 'kern');
      }
      return features;
    };

    DefaultShaper.assignFeatures = function(glyphs, script) {
      var end, glyph, i, start;
      i = 0;
      while (i < glyphs.length) {
        glyph = glyphs[i];
        if (glyph.codePoints[0] === 0x2044) {
          start = i - 1;
          end = i + 1;
          while (start >= 0 && unicode.isDigit(glyphs[start].codePoints[0])) {
            glyphs[start].features.numr = true;
            glyphs[start].features.frac = true;
            start--;
          }
          while (end < glyphs.length && unicode.isDigit(glyphs[end].codePoints[0])) {
            glyphs[end].features.dnom = true;
            glyphs[end].features.frac = true;
            end++;
          }
          glyph.features.frac = true;
          i = end - 1;
        } else {
          i++;
        }
      }
      return ['frac', 'numr', 'dnom'];
    };

    return DefaultShaper;

  })();

  module.exports = DefaultShaper;

}).call(this);
